package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo._temp.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;

public class Locks
{
   TempRecord1.Buf tt = TemporaryBuffer.define(TempRecord1.Buf.class, "tt", false);

   final QueryWrapper query0 = new QueryWrapper(false);

   final QueryWrapper query1 = new QueryWrapper(false);

   public void execute()
   {
      externalProcedure(new Block()
      {
         handle h = new handle();

         handle hQuery = new handle();

         integer int1 = new integer(0);

         public void init()
         {
            TransactionManager.register(h, int1);
         }

         public void body()
         {
            RecordBuffer.openScope(tt);
            RecordBuffer.create(h, "tt");
            handle.unwrapBuffer(h).findFirst();
            handle.unwrapBuffer(h).findLast();
            handle.unwrapBuffer(h).findUnique();
            handle.unwrapQuery(hQuery).addBuffer(h);
            query1.changeForwardOnly(new logical(true));
            query1.prepare("FOR EACH tt NO-LOCK");
            query1.queryOpen();
            query1.getNext();
            query1.getNext(LockType.NONE);
            query1.getNext(LockType.NONE);
            query1.getNext(LockType.SHARE);
            query1.getNext(LockType.SHARE_NO_WAIT);
            query1.getNext(LockType.EXCLUSIVE);
            query1.getNext(LockType.EXCLUSIVE_NO_WAIT);
            query1.getNext(LockType.LT_NONE, 0);
            query1.getNext(LockType.LT_NONE, 7);
            query1.getNext(LockType.LT_NONE, plus(7, 1));
            query1.getNext(LockType.LT_SHARE, 0);
            query1.getNext(LockType.LT_SHARE, 7);
            query1.getNext(LockType.LT_SHARE, plus(7, 1));
            query1.getNext(LockType.LT_EXCLUSIVE, 0);
            query1.getNext(LockType.LT_EXCLUSIVE, 7);
            query1.getNext(LockType.LT_EXCLUSIVE, plus(7, 1));
            query1.getNext(plus(7, 1), LockType.LT_NO_WAIT);
            query1.getNext(7, LockType.LT_NO_WAIT);
            query1.getNext(0, LockType.LT_NO_WAIT);
            query1.getNext(LockType.LT_NONE, int1);
            query1.getNext(LockType.LT_SHARE, int1);
            query1.getNext(LockType.LT_EXCLUSIVE, int1);
            query1.getNext(int1, LockType.LT_NO_WAIT);
            query1.getNext(LockType.LT_NONE, plus(int1, 1));
            query1.getNext(plus(int1, 1), LockType.LT_NO_WAIT);
            query1.getNext(6209);
            query1.getNext(6209, 6090);
            query1.getNext(6209, 0);
            query1.getNext(6208);
            query1.getNext(6208, 6090);
            query1.getNext(6208, 0);
            query1.getNext(6207);
            query1.getNext(6207, 6090);
            query1.getNext(6207, 0);
            query1.getNext(1111);
            query1.getNext(2222, 3333);
            query1.getPrevious();
            query1.getPrevious(LockType.NONE);
            query1.getPrevious(LockType.NONE);
            query1.getPrevious(LockType.SHARE);
            query1.getPrevious(LockType.SHARE_NO_WAIT);
            query1.getPrevious(LockType.EXCLUSIVE);
            query1.getPrevious(LockType.EXCLUSIVE_NO_WAIT);
            query1.getPrevious(LockType.LT_NONE, 0);
            query1.getPrevious(LockType.LT_NONE, 7);
            query1.getPrevious(LockType.LT_NONE, plus(7, 1));
            query1.getPrevious(LockType.LT_SHARE, 0);
            query1.getPrevious(LockType.LT_SHARE, 7);
            query1.getPrevious(LockType.LT_SHARE, plus(7, 1));
            query1.getPrevious(LockType.LT_EXCLUSIVE, 0);
            query1.getPrevious(LockType.LT_EXCLUSIVE, 7);
            query1.getPrevious(LockType.LT_EXCLUSIVE, plus(7, 1));
            query1.getPrevious(plus(7, 1), LockType.LT_NO_WAIT);
            query1.getPrevious(7, LockType.LT_NO_WAIT);
            query1.getPrevious(0, LockType.LT_NO_WAIT);
            query1.getPrevious(LockType.LT_NONE, int1);
            query1.getPrevious(LockType.LT_SHARE, int1);
            query1.getPrevious(LockType.LT_EXCLUSIVE, int1);
            query1.getPrevious(int1, LockType.LT_NO_WAIT);
            query1.getPrevious(LockType.LT_NONE, plus(int1, 1));
            query1.getPrevious(plus(int1, 1), LockType.LT_NO_WAIT);
            query1.getPrevious(6209);
            query1.getPrevious(6209, 6090);
            query1.getPrevious(6209, 0);
            query1.getPrevious(6208);
            query1.getPrevious(6208, 6090);
            query1.getPrevious(6208, 0);
            query1.getPrevious(6207);
            query1.getPrevious(6207, 6090);
            query1.getPrevious(6207, 0);
            query1.getPrevious(1111);
            query1.getPrevious(2222, 3333);
            query1.getFirst();
            query1.getFirst(LockType.NONE);
            query1.getFirst(LockType.NONE);
            query1.getFirst(LockType.SHARE);
            query1.getFirst(LockType.SHARE_NO_WAIT);
            query1.getFirst(LockType.EXCLUSIVE);
            query1.getFirst(LockType.EXCLUSIVE_NO_WAIT);
            query1.getFirst(LockType.LT_NONE, 0);
            query1.getFirst(LockType.LT_NONE, 7);
            query1.getFirst(LockType.LT_NONE, plus(7, 1));
            query1.getFirst(LockType.LT_SHARE, 0);
            query1.getFirst(LockType.LT_SHARE, 7);
            query1.getFirst(LockType.LT_SHARE, plus(7, 1));
            query1.getFirst(LockType.LT_EXCLUSIVE, 0);
            query1.getFirst(LockType.LT_EXCLUSIVE, 7);
            query1.getFirst(LockType.LT_EXCLUSIVE, plus(7, 1));
            query1.getFirst(plus(7, 1), LockType.LT_NO_WAIT);
            query1.getFirst(7, LockType.LT_NO_WAIT);
            query1.getFirst(0, LockType.LT_NO_WAIT);
            query1.getFirst(LockType.LT_NONE, int1);
            query1.getFirst(LockType.LT_SHARE, int1);
            query1.getFirst(LockType.LT_EXCLUSIVE, int1);
            query1.getFirst(int1, LockType.LT_NO_WAIT);
            query1.getFirst(LockType.LT_NONE, plus(int1, 1));
            query1.getFirst(plus(int1, 1), LockType.LT_NO_WAIT);
            query1.getFirst(6209);
            query1.getFirst(6209, 6090);
            query1.getFirst(6209, 0);
            query1.getFirst(6208);
            query1.getFirst(6208, 6090);
            query1.getFirst(6208, 0);
            query1.getFirst(6207);
            query1.getFirst(6207, 6090);
            query1.getFirst(6207, 0);
            query1.getFirst(1111);
            query1.getFirst(2222, 3333);
            query1.getLast();
            query1.getLast(LockType.NONE);
            query1.getLast(LockType.NONE);
            query1.getLast(LockType.SHARE);
            query1.getLast(LockType.SHARE_NO_WAIT);
            query1.getLast(LockType.EXCLUSIVE);
            query1.getLast(LockType.EXCLUSIVE_NO_WAIT);
            query1.getLast(LockType.LT_NONE, 0);
            query1.getLast(LockType.LT_NONE, 7);
            query1.getLast(LockType.LT_NONE, plus(7, 1));
            query1.getLast(LockType.LT_SHARE, 0);
            query1.getLast(LockType.LT_SHARE, 7);
            query1.getLast(LockType.LT_SHARE, plus(7, 1));
            query1.getLast(LockType.LT_EXCLUSIVE, 0);
            query1.getLast(LockType.LT_EXCLUSIVE, 7);
            query1.getLast(LockType.LT_EXCLUSIVE, plus(7, 1));
            query1.getLast(plus(7, 1), LockType.LT_NO_WAIT);
            query1.getLast(7, LockType.LT_NO_WAIT);
            query1.getLast(0, LockType.LT_NO_WAIT);
            query1.getLast(LockType.LT_NONE, int1);
            query1.getLast(LockType.LT_SHARE, int1);
            query1.getLast(LockType.LT_EXCLUSIVE, int1);
            query1.getLast(int1, LockType.LT_NO_WAIT);
            query1.getLast(LockType.LT_NONE, plus(int1, 1));
            query1.getLast(plus(int1, 1), LockType.LT_NO_WAIT);
            query1.getLast(6209);
            query1.getLast(6209, 6090);
            query1.getLast(6209, 0);
            query1.getLast(6208);
            query1.getLast(6208, 6090);
            query1.getLast(6208, 0);
            query1.getLast(6207);
            query1.getLast(6207, 6090);
            query1.getLast(6207, 0);
            query1.getLast(1111);
            query1.getLast(2222, 3333);
            query1.getCurrent();
            query1.getCurrent(LockType.NONE);
            query1.getCurrent(LockType.NONE);
            query1.getCurrent(LockType.SHARE);
            query1.getCurrent(LockType.SHARE_NO_WAIT);
            query1.getCurrent(LockType.EXCLUSIVE);
            query1.getCurrent(LockType.EXCLUSIVE_NO_WAIT);
            query1.getCurrent(LockType.LT_NONE, 0);
            query1.getCurrent(LockType.LT_NONE, 7);
            query1.getCurrent(LockType.LT_NONE, plus(7, 1));
            query1.getCurrent(LockType.LT_SHARE, 0);
            query1.getCurrent(LockType.LT_SHARE, 7);
            query1.getCurrent(LockType.LT_SHARE, plus(7, 1));
            query1.getCurrent(LockType.LT_EXCLUSIVE, 0);
            query1.getCurrent(LockType.LT_EXCLUSIVE, 7);
            query1.getCurrent(LockType.LT_EXCLUSIVE, plus(7, 1));
            query1.getCurrent(plus(7, 1), LockType.LT_NO_WAIT);
            query1.getCurrent(7, LockType.LT_NO_WAIT);
            query1.getCurrent(0, LockType.LT_NO_WAIT);
            query1.getCurrent(LockType.LT_NONE, int1);
            query1.getCurrent(LockType.LT_SHARE, int1);
            query1.getCurrent(LockType.LT_EXCLUSIVE, int1);
            query1.getCurrent(int1, LockType.LT_NO_WAIT);
            query1.getCurrent(LockType.LT_NONE, plus(int1, 1));
            query1.getCurrent(plus(int1, 1), LockType.LT_NO_WAIT);
            query1.getCurrent(6209);
            query1.getCurrent(6209, 6090);
            query1.getCurrent(6209, 0);
            query1.getCurrent(6208);
            query1.getCurrent(6208, 6090);
            query1.getCurrent(6208, 0);
            query1.getCurrent(6207);
            query1.getCurrent(6207, 6090);
            query1.getCurrent(6207, 0);
            query1.getCurrent(1111);
            query1.getCurrent(2222, 3333);
         }
      });
   }
}
